DL_PrivateKey_EC< EC > Class Template Reference

Elliptic Curve Discrete Log (DL) private key. More...

`#include <eccrypto.h>`

Inheritance diagram for DL_PrivateKey_EC< EC >:

## Public Types

typedef EC::Point | Element
Public Types inherited from DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >
typedef DL_GroupParameters_EC< EC >::Element | Element
Public Types inherited from DL_PrivateKey< DL_GroupParameters_EC< EC >::Element >
typedef DL_GroupParameters_EC< EC >::Element | Element
Public Types inherited from DL_KeyImpl< PKCS8PrivateKey, DL_GroupParameters_EC< EC > >
typedef DL_GroupParameters_EC< EC > | GroupParameters

## Public Member Functions

void | Initialize (const DL_GroupParameters_EC< EC > &params, const Integer &x)
| Initialize an EC Private Key using {GP,x}.
void | Initialize (const EC &ec, const Element &G, const Integer &n, const Integer &x)
| Initialize an EC Private Key using {EC,G,n,x}.
void | Initialize (RandomNumberGenerator &rng, const DL_GroupParameters_EC< EC > &params)
| Create an EC private key.
void | Initialize (RandomNumberGenerator &rng, const EC &ec, const Element &G, const Integer &n)
| Create an EC private key.
void | BERDecodePrivateKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| Decode privateKey part of privateKeyInfo.
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo.
Public Member Functions inherited from DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| Generate a random key or crypto parameters.
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation.
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters.
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters.
const Integer & | GetPrivateExponent () const
| Retrieves the private exponent.
void | SetPrivateExponent (const Integer &x)
| Sets the private exponent.
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| Decode privateKey part of privateKeyInfo.
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo.
Public Member Functions inherited from DL_PrivateKey< DL_GroupParameters_EC< EC >::Element >
void | MakePublicKey (DL_PublicKey< DL_GroupParameters_EC< EC >::Element > &pub) const
| Initializes a public key from this key.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key.
Public Member Functions inherited from DL_KeyImpl< PKCS8PrivateKey, DL_GroupParameters_EC< EC > >
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const DL_GroupParameters_EC< EC > & | GetGroupParameters () const
DL_GroupParameters_EC< EC > & | AccessGroupParameters ()
Public Member Functions inherited from PKCS8PrivateKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| Decode optional attributes.
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| Encode optional attributes.
Public Member Functions inherited from ASN1CryptoMaterial< PrivateKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object.
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object.
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T>
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T>
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T>
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

template<class EC>
class DL_PrivateKey_EC< EC >

Elliptic Curve Discrete Log (DL) private key.

Template Parameters

  EC | elliptic curve field

Definition at line 209 of file eccrypto.h.

## Member Typedef Documentation

## Element

template<class EC>

typedef EC::Point DL_PrivateKey_EC< EC >::Element

Definition at line 212 of file eccrypto.h.

## Constructor & Destructor Documentation

## ~DL_PrivateKey_EC()

template<class EC>

DL_PrivateKey_EC< EC >::~DL_PrivateKey_EC | ( |  | ) |

virtual

Definition at line 259 of file eccrypto.h.

## Member Function Documentation

## Initialize() [1/4]

template<class EC>

void DL_PrivateKey_EC< EC >::Initialize | ( | const DL_GroupParameters_EC< EC > & | params,
|  | const Integer & | x )

inline

Initialize an EC Private Key using {GP,x}.

Parameters

  params | group parameters
  x | the private exponent

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 220 of file eccrypto.h.

## Initialize() [2/4]

template<class EC>

void DL_PrivateKey_EC< EC >::Initialize | ( | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n,
|  | const Integer & | x )

inline

Initialize an EC Private Key using {EC,G,n,x}.

Parameters

  ec | the elliptic curve
  G | the base point
  n | the order of the base point
  x | the private exponent

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 229 of file eccrypto.h.

## Initialize() [3/4]

template<class EC>

void DL_PrivateKey_EC< EC >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const DL_GroupParameters_EC< EC > & | params )

inline

Create an EC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  params | the EC group parameters

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 238 of file eccrypto.h.

## Initialize() [4/4]

template<class EC>

void DL_PrivateKey_EC< EC >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n )

inline

Create an EC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  ec | the elliptic curve
  G | the base point
  n | the order of the base point

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 249 of file eccrypto.h.

## BERDecodePrivateKey()

template<class EC>

void DL_PrivateKey_EC< EC >::BERDecodePrivateKey | ( | BufferedTransformation & | bt,
|  | bool | parametersPresent,
|  | size_t | size )

virtual

Decode privateKey part of privateKeyInfo.

Parameters

  bt | BufferedTransformation object
  parametersPresent | flag indicating if algorithm parameters are present
  size | number of octets to read for the parameters, in bytes

BERDecodePrivateKey() the decodes privateKey part of privateKeyInfo, without the OCTET STRING header.

When parametersPresent = true then BERDecodePrivateKey() calls BERDecodeAlgorithmParameters() to parse algorithm parameters.

See also
  BERDecodeAlgorithmParameters

Implements PKCS8PrivateKey.

## DEREncodePrivateKey()

template<class EC>

void DL_PrivateKey_EC< EC >::DEREncodePrivateKey | ( | BufferedTransformation & | bt | ) | const

virtual

Encode privateKey part of privateKeyInfo.

Parameters

  bt | BufferedTransformation object

DEREncodePrivateKey() encodes the privateKey part of privateKeyInfo, without the OCTET STRING header.

See also
  DEREncodeAlgorithmParameters

Implements PKCS8PrivateKey.

The documentation for this class was generated from the following file:

- eccrypto.h